import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String name, long salary) {
    Professor emp = new Professor();
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Professor setProfessorDepartment(int empId, int deptId) {
    Professor emp = em.find(Professor.class, empId);
    Department dept = em.find(Department.class, deptId);
    emp.setDepartment(dept);
    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

  public Department createDepartment(String name) {
    Department dept = new Department();
    dept.setName(name);
    em.persist(dept);

    return dept;
  }

  public Collection<Department> findAllDepartments() {
    Query query = em.createQuery("SELECT d FROM Department d");
    return (Collection<Department>) query.getResultList();
  }
}
